---
title: RTCPeerConnection.onicecandidate
slug: Web/API/RTCPeerConnection/onicecandidate
tags:
  - API
  - Candidate
  - Event Handler
  - ICE
  - Negotiation
  - Property
  - RTCPeerConnection
  - Reference
  - SDP
  - WebRTC
  - WebRTC API
  - onicecandidate
---
<p>{{APIRef("WebRTC")}}</p>

<p><span class="seoSummary">The <code>RTCPeerConnection</code> property <strong>{{domxref("RTCPeerConnection.onicecandidate", "onicecandidate")}}</strong> property is an {{domxref("EventHandler")}} which specifies a function to be called when the {{event("icecandidate")}} event occurs on an {{domxref("RTCPeerConnection")}} instance. This happens whenever the local {{Glossary("ICE")}} agent needs to deliver a message to the other peer through the signaling server.</span> This lets the ICE agent perform negotiation with the remote peer without the browser itself needing to know any specifics about the technology being used for signaling; implement this method to use whatever messaging technology you choose to send the ICE candidate to the remote peer.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>rtcPeerConnection</em>.onicecandidate = <em>eventHandler</em>;
</pre>

<h3 id="Value">Value</h3>

<p>This should be set to a function which you provide that accepts as input an {{domxref("RTCPeerConnectionIceEvent")}} object representing the {{event("icecandidate")}} event. The function should deliver the ICE candidate, whose {{Glossary("SDP")}} can be found in the event's {{domxref("RTCPeerConnectionIceEvent.candidate", "candidate")}} property, to the remote peer through the signaling server.</p>

<p>If the event's <code>candidate</code> property is <code>null</code>, ICE gathering has finished. This message should not be sent to the remote peer. When this happens, the connection's {{domxref("RTCPeerConnection.iceGatheringState", "iceGatheringState")}} has also changed to <code>complete</code>. You don't need to watch for this explicitly; instead, if you need to sense the end of signaling, you should watch for a {{domxref("RTCPeerConnection.icegatheringstatechange_event", "icegatheringstatechange")}} event indicating that the ICE negotiation has transitioned to the <code>complete</code> state.</p>

<h2 id="Example">Example</h2>

<p>The example below, which is based on the code from the article <a href="/en-US/docs/Web/API/WebRTC_API/Signaling_and_video_calling">Signaling and video calling</a>, sets up a handler for {{event("icecandidate")}} events to send the candidates to the remote peer.</p>

<pre class="brush: js">pc.onicecandidate = function(event) {
  if (event.candidate) {
    // Send the candidate to the remote peer
  } else {
    // All ICE candidates have been sent
  }
}</pre>

<p>Notice that the end of negotiation is detected here when the event's {{domxref("RTCPeerConnectionIceEvent.candidate", "candidate")}} property is <code>null</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-rtcpeerconnection-onicecandidate', 'RTCPeerConnection.onicecandidate') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.onicecandidate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{event("icecandidate")}} event and its type, {{domxref("RTCPeerConnectionIceEvent")}}.</li>
</ul>
